


// tellem.cpp - once a minute or so, broadcast our address and name 
// over udp port 53831 to IP 192.168.1.255 so others can find us
// on the lan, even once we get dchp working as it should here.

// Required header
#include    <HTTPServer.h>
#include <SD.h> // for logger stuff

// =================================================================
// =================================================================
// function to return the amount of free RAM - 2014 Dave Knight
//
// variables created by the build process when compiling the sketch

unsigned long freeRAM ()
{
  char v;
  void *sp = &v, *ht;
//  Serial.print("sp:");
//  Serial.println((unsigned long)sp);
  ht = malloc(100);
  free(ht);
//  Serial.print("ht:");
//  Serial.println((unsigned long)ht);
  if (ht == NULL) {
    return 0;  // < 100 bytes left
  }
  return (unsigned long) sp - (unsigned long) ht;
}




// static const in rom
static const char * szIPServer = "255.255.255.255"; // bcast IP 
// 192.168,1.255 doesn't work, but it does everywhere else (perl, cpp, PC)
static const unsigned short portServer = 53831; // tellem port 

// actually send a UDP packet with our IP and name to broadcast addr
void doit()
{
 char tellemsg[30]; // actually about 20 char this msg + null, so we have 9 fudge
 byte UDPCache[60]; // 2k seems too large for this...
 UdpClient udpClient(UDPCache,sizeof(UDPCache));  // create UDP client 
 IPv4 ipMy; // their union of integer and 4 bytes (numeric all)
 DNETcK::getMyIP(&ipMy); // fill it with their helper func 
 GetNumb(ipMy.rgbIP,4,'.',tellemsg); // gets dotted quad ascii
 // now add our name after a space char
 strcat(tellemsg, " WF321"); //@@@ hardcoded name here, ugh
 // now figure out how to send this UDP broadcast to the world
 udpClient.setEndPoint(szIPServer,portServer); // broadcast to our special port
 udpClient.writeDatagram((byte *)tellemsg,strlen(tellemsg)); // ship it out
 //Serial.println(tellemsg); // debug
 Serial.print(" free ram in tellem:");
  Serial.println (freeRAM(),DEC);
}
////////////////////////// timing function - limit to one per minute
void tellem() // called in loop (we hope) to announce our presence
{
 static unsigned long timez = 0; // time since last call
 if (millis() - timez > 60000) // has it been a minute?
 {
  doit();
  timez = millis(); // get ready for next minute
 } 
  
}
/*************************************************************************

    Data logging stuff here

/*************************************************************************/

////////////////// ran out of this dumb ide's ability to add files, so this
// gets to go here, instead - the data logging stuff

void dolog()
{
  unsigned long epochTime;
  epochTime = DNETcK::secondsSinceEpoch();
  if (1400000000 < epochTime)
  {
   Serial.print("logging function\t");
   Serial.println(epochTime,DEC);
  }

}
////////////////////////////////////////////////////////////
void loggit() // actually, just check if it's time to do it
{
 static unsigned long intervalz = 0; 
 if (millis() - intervalz > 10000) // has it been a 10 sec?
 {
  intervalz = millis(); // get ready for next round   
  dolog();
 }   
}




